#define NEW(x) "(_new " #x ")"
#define LEN(x) "(_strlen " x ")"
#define SUBSTR_A(i,j) "(A _str " i " _str " j ")"
#define CHAR(A,i) "(" A " _str " #i" _str " #i ")"
#define CHAR_A(i) "(A _str " #i " _str " #i ")"
#define CHAR_Ai(i) "(A _str " i " _str " i ")"
#define EQ(S1,S2) "(" S1 " == " S2 ")"
#define NEQ(S1,S2) "(" S1 " != " S2 ")"
#define IMPLIES(S1,S2) "(" S1 " => " S2 ")"
#define AND(S1,S2) "(" S1 " && " S2 ")"
#define AND3(S1,S2,S3) "(" S1 " && " S2  " && " S3 ")"
#define AND4(S1,S2,S3,S4) "(" S1 " && " S2  " && " S3 " && " S4 ")"
#define AND6(S1,S2,S3,S4,S5,S6) "(" S1 " && " S2  " && " S3 " && " S4 " && " S5 " && " S6 ")"
#define ADD(S1,S2) "(" S1 " + " S2 ")"
#define SUB(S1,S2) "(" S1 " - " S2 ")"
#define LTE(S1,S2) "(" S1 " <= " S2 ")"
#define LT(S1,S2) "(" S1 " < " S2 ")"
#define INCR(S) "(" S " + 1)"
#define CAT(S1,S2) "(" S1 " _catone " S2 ")"
#define APPEND(S1,S2) "(" S1 " _append " S2 ")"
#define PATT1(P) "(:pat " P ")"
#define ANDPATT(P1,P2) "(" P1 " :pat " P2 ")"
#define QUANT2(q1,q2)  #q1 " forall " #q2
#define QUANT3(q1,q2,q3)  #q1 " forall " #q2 " forall " #q3
#define QUANT4(q1,q2,q3,q4)  #q1 " forall " #q2 " forall " #q3 " forall " #q4
#define QUANT5(q1,q2,q3,q4,q5)  #q1 " forall " #q2 " forall " #q3 " forall " #q4 " forall " #q5
#define QUANT6(q1,q2,q3,q4,q5,q6)  #q1 " forall " #q2 " forall " #q3 " forall " #q4 " forall " #q5 " forall " #q6
#define FORALL(q,f,p) "(" q " forall " f " forall " p ")"

char *AXIOMS =
EQ(LEN(NEW(1)), "1") "; " // single char initializer 1
EQ(LEN(NEW(2)), "1") "; " // single char initializer 2
EQ(LEN(NEW(0)), "0") "; " // empty string
NEQ(NEW(1), NEW(2)) "; " 
NEQ(NEW(0), NEW(1)) "; " 
NEQ(NEW(0), NEW(2)) "; " // distinctness of characters
EQ(CHAR(NEW(1),0), NEW(1)) "; " // single char strings 1
EQ(CHAR(NEW(2),0), NEW(2)) "; " // single char strings 2
// strlen of catone
FORALL(QUANT2(P,Q), \
	   EQ(LEN(CAT("P","Q")), INCR(LEN("P"))), \
	   PATT1(LEN(CAT("P","Q")))) "; "
// single chars match at least one in the domain of chars
FORALL(QUANT2(A,k), \
	   IMPLIES(NEQ(CHAR_A(k),NEW(1)), EQ(CHAR_A(k),NEW(2))), \
	   PATT1(CHAR_A(k))) ";"
// relates strlen and substring. required when differing lengths imply that string cannot be equal
FORALL(QUANT3(A,k1,k2), \
	   EQ( LEN(SUBSTR_A("k1","k2")), INCR(SUB("k2","k1")) ), \
	   PATT1(SUBSTR_A("k1","k2"))) "; "
// init case of single char strings
FORALL(QUANT3(A,AA,X), \
	   IMPLIES(AND(EQ("A", APPEND("AA","X")), EQ(NEW(0),"AA")), EQ("A","X")), \
	   PATT1(ANDPATT( EQ("A", APPEND("AA","X")), EQ(NEW(0),"AA") ))) "; "
// inductive case for string appends
FORALL(QUANT5(X,Y,B,A,a), \
	   IMPLIES( \
		AND3( \
		     EQ("X",SUBSTR_A("0","a")), \
			 EQ("Y",APPEND("X","B")), \
			 EQ("B", SUBSTR_A(INCR("a"),ADD("a",LEN("B")))) \
		) , \
		EQ("Y", SUBSTR_A("0", ADD("a",LEN("B")))) \
	   ), \
	   PATT1(ANDPATT(EQ("X", SUBSTR_A("0","a")), EQ("Y",APPEND("X","B")))) \
) "; "				
// inductive case for string appends with catone
FORALL(QUANT6(X,Y,Q,C,A,a), \
	   IMPLIES( \
			AND4( \
				EQ("X",SUBSTR_A("0","a")), \
				EQ("Y",APPEND("X", CAT("Q","C"))), \
				EQ(CHAR("C",0), CHAR_Ai(INCR(ADD("a",LEN("Q"))))), \
				EQ("Q", SUBSTR_A(INCR("a"),ADD("a",LEN("Q")))) \
			), \
			EQ("Y", SUBSTR_A("0",INCR(ADD("a",LEN("Q"))))) \
	   ), \
	   PATT1(ANDPATT(EQ("X", SUBSTR_A("0","a")), EQ("Y", APPEND("X",CAT("Q","C"))))) \
) "; "
// substring equality
FORALL(QUANT6(A,i,j,p,q,t), \
	   IMPLIES( \
	       AND6(EQ(SUBSTR_A("i","j"), SUBSTR_A("p","q")), LTE("i","t"),  LTE("t","j"), LT("i","j"), LT("p","q"), NEQ("i","p") ), \
		   AND( EQ(CHAR_A(t), CHAR_Ai(ADD("t", SUB("p","i")))), EQ(SUB("q","p"),SUB("j","i")) ) \
	   ), \
	   PATT1(ANDPATT(CHAR_A(t), EQ(SUBSTR_A("i","j"), SUBSTR_A("p","q")))) \
) "; "
;